    /**
     * Adds a role to the ACL list. Second parameter allows inheriting access data from other existing role
     *
     * ```php
     * $acl->addRole(
     *     new Phalcon\Acl\Role("administrator"),
     *     "consultant"
     * );
     *
     * $acl->addRole("administrator", "consultant");
     * $acl->addRole("administrator", ["consultant", "consultant2"]);
     * ```
     */
    public function addRole(role, accessInherits = null) -> bool
    {
        var roleName, roleObject;

        if typeof role == "object" && role instanceof RoleInterface {
            let roleObject = role;
        } elseif is_string(role) {
            let roleObject = new Role(role);
        } else {
            throw new Exception(
                "Role must be either a string or implement RoleInterface"
            );
        }

        let roleName = roleObject->getName();

        if isset this->rolesNames[roleName] {
            return false;
        }